<?php

/*
  #########################################################################
  #                       xt:Commerce VEYTON 5.0 Shopsoftware
  # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  #
  # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
  # This file may not be redistributed in whole or significant part.
  # Content of this file is Protected By International Copyright Laws.
  #
  # ~~~~~~ xt:Commerce VEYTON 5.0 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
  #
  # http://www.xt-commerce.com
  #
  # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  #
  # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
  #
  # office@xt-commerce.com
  #
  #########################################################################
 */
defined('_VALID_CALL') or die('Direct Access is not allowed.');

/**
 * Class ekomi_integration.
 */
class ekomi_integration
{
    /**
     * Enable/Disable values.
     */
    const EKOMI_INTEGRATION_VALUE_TRUE = 'true';
    const EKOMI_INTEGRATION_VALUE_FALSE = 'false';
    const EKOMI_INTEGRATION_ENABLE = '1';
    const EKOMI_INTEGRATION_DISABLE = '0';

    /**
     * The URL where the order data is sent.
     */
    const URL_TO_SEND_DATA = 'https://plugins-dashboard.ekomiapps.de/api/v1/order';

    /**
     * The Url to validate shop.
     */
    const URL_GET_SETTINGS = 'http://api.ekomi.de/v3/getSettings';

    /**
     * Response from getSettings Api.
     */
    const GET_SETTINGS_RESPONSE = 'Access denied';

    /**
     * Responses Codes.
     */
    const RESPONSE_NOT_FOUND = 404;
    const MESSAGE_TYPE_ERROR = 3;

    /**
     * Gets parameters.
     *
     * @return array
     */
    public function _getParams()
    {
        global $language, $xtPlugin;

        if (empty($this->url_data['get_data']) && empty($this->url_data['edit_id'])) {
            unset($_SESSION['filters_ekomi_integration']);
        }

        $header = array(
            'order_status' => array('type' => 'dropdown_multi', 'url' => 'DropdownData.php?get=order_status'),
        );
        $header['EKOMI_INTEGRATION_SHOP_SECRET'] = array('required' => 'true');

        ($plugin_code = $xtPlugin->PluginCode('class.ekomi_integration.php:_getParams_header')) ? eval($plugin_code) : false;

        $params = array(
            'header' => $header,
        );

        ($plugin_code = $xtPlugin->PluginCode('class.ekomi_integration.php:_getParams_bottom')) ? eval($plugin_code) : false;

        return $params;
    }

    /**
     * Verifies Shop Id and Secret.
     *
     * @param int    $shopId
     * @param string $shopSecret
     *
     * @return bool
     */
    public function verifyAccount($shopId, $shopSecret)
    {
        $ApiUrl = self::URL_GET_SETTINGS . "?auth={$shopId}|{$shopSecret}";
        $ApiUrl .= '&version=cust-1.0.0&type=request&charset=iso&app=PD-xt-commerce';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $ApiUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);
        if (self::GET_SETTINGS_RESPONSE == $response) {
            return false;
        }

        return true;
    }

    /**
     * Sends order data to Plugins-Dashboard.
     *
     * @param string $fields
     *
     * @return string
     */
    public function sendDataToPD($fields)
    {
        $boundary = md5(time());
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, self::URL_TO_SEND_DATA);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('ContentType:multipart/form-data;boundary=' . $boundary));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        $response = curl_exec($ch);
        curl_close($ch);

        return json_decode($response, true);
    }

    /**
     * Checks if product reviews enabled.
     *
     * @return bool
     */
    public function isProductReviewsEnabled()
    {
        if (self::EKOMI_INTEGRATION_VALUE_TRUE == EKOMI_INTEGRATION_PRODUCT_REVIEWS ||
            self::EKOMI_INTEGRATION_ENABLE == EKOMI_INTEGRATION_PRODUCT_REVIEWS
        ) {
            return true;
        }

        return false;
    }
}
