<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

global $page;
global $db;

include_once _SRV_WEBROOT . _SRV_WEB_PLUGINS . 'ekomi_integration/classes/class.ekomi_integration.php';
include_once _SRV_WEBROOT . _SRV_WEB_PLUGINS . 'ekomi_integration/classes/class.db_handler.php';

$ekomiIntegration = new ekomi_integration();
$dbHandler = new db_handler($db);
$shopId = trim(EKOMI_INTEGRATION_SHOP_ID);
$shopSecret = trim(EKOMI_INTEGRATION_SHOP_SECRET);
$orderId = $data_array['orders_id'];
if (ekomi_integration::EKOMI_INTEGRATION_VALUE_TRUE == EKOMI_INTEGRATION_ACTIVE && ekomi_integration::EKOMI_INTEGRATION_VALUE_TRUE == EKOMI_INTEGRATION_TERMS_AND_CONDITIONS) {
    if ($ekomiIntegration->verifyAccount($shopId, $shopSecret)) {
        $orderStatusId = $data_array['orders_status_id'];
        $ConfiguredOrderStatuses = array(EKOMI_INTEGRATION_ORDER_STATUS_OPEN, EKOMI_INTEGRATION_ORDER_STATUS_PAYMENT_RECEIVED, EKOMI_INTEGRATION_ORDER_STATUS_SHIPPED);
        if (in_array($orderStatusId, $ConfiguredOrderStatuses)) {
            $orderData = $dbHandler->getOrderData($orderId);
            $fields = array(
                'shop_id' => $shopId,
                'interface_password' => $shopSecret,
                'order_data' => $orderData,
                'mode' => EKOMI_INTEGRATION_MOD,
                'product_reviews' => $ekomiIntegration->isProductReviewsEnabled(),
                'plugin_name' => 'xt-commerce',
            );
            $fields = json_encode($fields);
            $response = $ekomiIntegration->sendDataToPD($fields);
            if (ekomi_integration::RESPONSE_NOT_FOUND == $response['code']) {
                $response = json_encode($response);
                error_log(
                    '[' . date('d-m-Y H:i:s') . " orderId:{$orderId} data:$response]" . PHP_EOL,
                    ekomi_integration::MESSAGE_TYPE_ERROR,
                    __DIR__ . '/errors.log'
                );
            }
        }
    } else {
        error_log(
            '[' . date('d-m-Y H:i:s') . " orderId:{$orderId}" . 'msg:Invalid shop id & password.]' . PHP_EOL,
            ekomi_integration::MESSAGE_TYPE_ERROR,
            __DIR__ . '/errors.log'
        );
    }
}
